#pragma once

#if 1

class CWin32IOWrapper;

class DCRaw
{
protected:
	struct Decode {
	  Decode *branch[2];
	  int leaf;
	};

	struct JHead {
	  int bits, high, wide, clrs, restart, vpred[4];
	  Decode *huff[4];
	  ushort *row;
	};

protected:
	void        merror (void *ptr, char *where);
	ushort      sget2 (uchar *s);
	ushort      get2();
	int         sget4 (uchar *s);
	int         get4();
	int         getint (int type);
	float       int_to_float (int i);
	double      getreal (int type);
	void        read_shorts (ushort *pixel, int count);
	void        canon_600_fixed_wb (int temp);
	int         canon_600_color (int ratio[2], int mar);
	void        canon_600_auto_wb();
	void        canon_600_coeff();
	void        canon_600_load_raw();
	void        canon_a5_load_raw();
	unsigned    getbits (int nbits);
	void        init_decoder();
	uchar *     make_decoder (const uchar *source, int level);
	void        crw_init_tables (unsigned table);
	int         canon_has_lowbits();
	void        canon_compressed_load_raw();
	int         ljpeg_start (JHead *jh, int info_only);
	int         ljpeg_diff (Decode *dindex);
	void        ljpeg_row (int jrow, JHead *jh);
	void        lossless_jpeg_load_raw();
	void        adobe_copy_pixel (int row, int col, ushort **rp);
	void        adobe_dng_load_raw_lj();
	void        adobe_dng_load_raw_nc();
	void        nikon_compressed_load_raw();
	void        nikon_load_raw();
	int         nikon_is_compressed();
	int         nikon_e995();
	int         nikon_e2100();
	int         nikon_3700();
	int         minolta_z2();
	void        nikon_e900_load_raw();
	void        nikon_e2100_load_raw();
	void        fuji_load_raw();
	void        jpeg_thumb (FILE *tfp);
	void        ppm_thumb (FILE *tfp);
	void        layer_thumb (FILE *tfp);
	void        rollei_thumb (FILE *tfp);
	void        rollei_load_raw();
	int         bayer (unsigned row, unsigned col);
	void		phase_one_flat_field(int is_float, int nc);
	void        phase_one_correct();
	void        phase_one_load_raw();
	unsigned    ph1_bits (int nbits);
	void        phase_one_load_raw_c();
	void        leaf_full_load_raw();
	void		imacon_full_load_raw();
	void        packed_12_load_raw();
	void        unpacked_load_raw();
	void        olympus_e300_load_raw();
	void        olympus_cseries_load_raw();
	void        minolta_rd175_load_raw();
	void        eight_bit_load_raw();
	void        casio_qv5700_load_raw();
	void        nucore_load_raw();
	const int * make_decoder_int (const int *source, int level);
	int         radc_token (int tree);
	void        kodak_radc_load_raw();
	void        kodak_jpeg_load_raw();
	void        kodak_dc120_load_raw();
	void        kodak_easy_load_raw();
	int         kodak_65000_decode (short *out, int bsize);
	void        kodak_65000_load_raw();
	void        kodak_ycbcr_load_raw();
	void        kodak_rgb_load_raw();
	void        kodak_thumb_load_raw();
	void        sony_decrypt (unsigned *data, int len, int start, int key);
	void        sony_load_raw();
	void        smal_decode_segment (unsigned seg[2][2], int holes);
	void        smal_v6_load_raw();
	int         median4 (int *p);
	void        fill_holes (int holes);
	void        smal_v9_load_raw();
	void        foveon_decoder (unsigned size, unsigned code);
	void        foveon_thumb (FILE *tfp);
	void        foveon_load_camf();
	void        foveon_load_raw();
	char *      foveon_camf_param (char *block, char *param);
	void *      foveon_camf_matrix (int dim[3], char *name);
	int         foveon_fixed (void *ptr, int size, char *name);
	float       foveon_avg (short *pix, int range[2], float cfilt);
	short *     foveon_make_curve (double max, double mul, double filt);
	void        foveon_make_curves(short **curvep, float dq[3], float div[3], float filt);
	int         foveon_apply_curve (short *curve, int i);
	void        foveon_interpolate();
	void        bad_pixels();
	void        pseudoinverse (double (*in)[3], double (*out)[3], int size);
	void        cam_xyz_coeff (double cam_xyz[4][3]);
	void        colorcheck();
	void        scale_colors();
	void        border_interpolate (int border);
	void        lin_interpolate();
	void        vng_interpolate();
	void        cam_to_cielab (ushort cam[4], float lab[3]);
	void        ahd_interpolate();
	void        bilateral_filter();
	void		recover_highlights();
	void        tiff_get (unsigned base, unsigned *tag, unsigned *type, unsigned *len, unsigned *save);
	void        parse_olympus_note (int base);
	void        parse_makernote (int base);
	void        get_timestamp (int reversed);
	void        parse_exif (int base);
	void		romm_coeff (float romm_cam[3][3]);
	void        parse_mos (int offset);
	int         parse_tiff_ifd (int base, int level);
	void        parse_tiff (int base);
	void        parse_minolta();
	void        parse_external_jpeg(const char *ifname);
	void        ciff_block_1030();
	void        parse_ciff (int offset, int length);
	void        parse_rollei();
	void        parse_phase_one (int base);
	void        parse_fuji (int offset);
	int         parse_jpeg (int offset);
	void        parse_riff();
	void        parse_smal (int offset, int fsize);
	char *      foveon_gets (int offset, char *str, int len);
	void        parse_foveon();
	void        adobe_coeff (char *make, char *model);
	void        simple_coeff (int index);
	short       guess_byte_order (int words);
	void        identify(const char *ifname);
	void        apply_profile (const char *input, const char *output);
	void        convert_to_rgb();
	void        fuji_rotate();
	int         flip_index (int row, int col);
	void        flip_image();
	void        write_ppm (FILE *ofp);
	void        write_ppm16 (FILE *ofp);
	void        write_psd (FILE *ofp);

	// Must match the METHODDEF and JMETHOD definitions in JpegLib
	//static boolean fill_input_buffer(j_decompress_ptr cinfo);

protected:
	// In the original C-code these were global variables. Have moved them to members for thread-safety.

	void (DCRaw::*write_thumb)(FILE *);
	void (DCRaw::*write_fun)(FILE *);
	void (DCRaw::*load_raw)();
	void (DCRaw::*thumb_load_raw)();

	//FILE *ifp;
	CWin32IOWrapper *pifw;
	short order;
	//char *ifname
	char make[64], model[72], model2[64], *meta_data, cdesc[5];
	float flash_used, canon_ev, iso_speed, shutter, aperture, focal_len;
	time_t timestamp;
	unsigned shot_order, kodak_cbpp, filters, unique_id;
	int profile_offset, profile_length;
	int thumb_offset, thumb_length, thumb_width, thumb_height, thumb_misc;
	int data_offset, strip_offset, curve_offset, meta_offset, meta_length;
	int tiff_nifds, tiff_flip, tiff_bps, tiff_compress;
	int raw_height, raw_width, top_margin, left_margin;
	int height, width, fuji_width, colors, tiff_samples;
	int black, maximum, raw_color, use_gamma;
	int iheight, iwidth, shrink, flip, xmag, ymag;
	int zero_after_ff, is_raw, dng_version, is_foveon;
	ushort (*image)[4], white[8][8], curve[0x1000], cr2_slice[3];
	float bright, sigma_d, sigma_r;
	int four_color_rgb, document_mode, highlight;
	int verbose, use_auto_wb, use_camera_wb, output_color;
	int fuji_layout, fuji_secondary, use_secondary;
	float cam_mul[4], pre_mul[4], rgb_cam[3][4];    // RGB from camera color
	float user_mul[4];

	int histogram[4][0x2000];

	Decode first_decode[2048], *second_decode, *free_decode;

	struct {
	  int width, height, bps, comp, phint, offset, flip, samples, bytes;
	} tiff_ifd[10];

	struct {
	  int format, key_off, black, black_off, split_col, tag_21a;
	  float tag_210;
	} ph1;

protected:
	// In the original C-code these were static variables inside functions. Have moved them to members for thread-safety.
	unsigned int getbits_bitbuf; //= 0;
	int getbits_vbits; //= 0;
	int getbits_reset; //= 0;
	int make_decoder_leaf;
	UINT64 ph1_bits_bitbuf; // = 0;
	int ph1_bits_vbits; // = 0;
	Decode *radc_token_dstart[18], *radc_token_dindex;
	unsigned sony_decrypt_pad[128], sony_decrypt_p;
	unsigned foveon_decoder_huff[1024];
	float cam_to_cielab_cbrt[0x10000], cam_to_cielab_xyz_cam[3][4];

	//char fill_input_buffer_jpeg_buffer[4096];

	CRITICAL_SECTION *m_pLcmsCS;
	HANDLE m_hAbortEvent;

public:

	DCRaw(CRITICAL_SECTION *pLcmsCS, HANDLE hAbortEvent)
	: m_pLcmsCS(pLcmsCS)
	, m_hAbortEvent(hAbortEvent)
	, write_thumb(0)
	, write_fun(0)
	, load_raw(0)
	, thumb_load_raw(0)
	, pifw(NULL)
	, getbits_bitbuf(0)
	, getbits_vbits(0)
	, getbits_reset(0)
	, make_decoder_leaf(0)
	, ph1_bits_bitbuf(0)
	, ph1_bits_vbits(0)
	, radc_token_dindex(0)
	, sony_decrypt_p(0)
	, order(0)
	, meta_data(NULL)
	, flash_used(0.0f)
	, canon_ev(0.0f)
	, iso_speed(0.0f)
	, shutter(0.0f)
	, aperture(0.0f)
	, focal_len(0.0f)
	, timestamp(0)
	, shot_order(0)
	, kodak_cbpp(0)
	, filters(0)
	, unique_id(0)
	, profile_offset(0)
	, profile_length(0)
	, thumb_offset(0)
	, thumb_length(0)
	, thumb_width(0)
	, thumb_height(0)
	, thumb_misc(0)
	, data_offset(0)
	, strip_offset(0)
	, curve_offset(0)
	, meta_offset(0)
	, meta_length(0)
	, tiff_nifds(0)
	, tiff_flip(0)
	, tiff_bps(0)
	, tiff_compress(0)
	, raw_height(0)
	, raw_width(0)
	, top_margin(0)
	, left_margin(0)
	, height(0)
	, width(0)
	, fuji_width(0)
	, colors(0)
	, tiff_samples(0)
	, black(0)
	, maximum(0)
	, raw_color(0)
	, use_gamma(0)
	, iheight(0)
	, iwidth(0)
	, shrink(0)
	, flip(0)
	, xmag(0)
	, ymag(0)
	, zero_after_ff(0)
	, is_raw(0)
	, dng_version(0)
	, is_foveon(0)
	, bright(1.0f)
	, sigma_d(0.0f)
	, sigma_r(0.0f)
	, four_color_rgb(0)
	, document_mode(0)
	, highlight(0)
	, verbose(0)
	, use_auto_wb(0)
	, use_camera_wb(0)
	, output_color(1)
	, fuji_layout(0)
	, fuji_secondary(0)
	, use_secondary(0)
	, second_decode(NULL)
	, free_decode(NULL)
	, image(NULL)
	{
		ZeroMemory(make, sizeof(make));
		ZeroMemory(model, sizeof(model));
		ZeroMemory(model2, sizeof(model2));
		ZeroMemory(cdesc, sizeof(cdesc));
		ZeroMemory(sony_decrypt_pad, sizeof(sony_decrypt_pad));
		ZeroMemory(foveon_decoder_huff, sizeof(foveon_decoder_huff));

		int i,j;

		for(i = 0; i < 18; i++) { radc_token_dstart[i] = NULL; }
		for(i = 0; i < 0x10000; i++) { cam_to_cielab_cbrt[i] = 0.0f; }
		for(i = 0; i < 3; i++) { for(j = 0; j < 4; j++) { cam_to_cielab_xyz_cam[i][j] = 0.0f; } }
		for(i = 0; i < 8; i++) { for(j = 0; j < 8; j++) { white[i][j] = 0; } }
		for(i = 0; i < 4; i++) { cam_mul[i] = 0.0f; }
		for(i = 0; i < 4; i++) { pre_mul[i] = 0.0f; }
		for(i = 0; i < 4; i++) { user_mul[i] = 0.0f; }
		for(i = 0; i < 3; i++) { for(j = 0; j < 4; j++) { rgb_cam[i][j] = 0.0f; } }
		for(i = 0; i < 3; i++) { cr2_slice[i] = 0; }

		ZeroMemory(histogram, sizeof(histogram));
		ZeroMemory(curve, sizeof(curve));
		ZeroMemory(first_decode, sizeof(first_decode));
		ZeroMemory(tiff_ifd, sizeof(tiff_ifd));
	}

	~DCRaw() // Warning: Non-virtual destructor. I don't plan on using this as a base-class.
	{
	}

	bool DoFile(const NJP2RawConfig::NJR_RawSettings *pImageSettings,
				CWin32IOWrapper *pInputFile,
				const char *szInputFilenameIfPhysicalFile,
				const char *szOutputFilename,
				std::string *pstrOutMake, std::string *pstrOutModel,
				int *piOutWidth, int *piOutHeight);
protected:
	bool DoFile_Raw(const char *szOutputFilename, int user_qual, int user_black, int use_fuji_rotate, const char *cam_profile, const char *out_profile);
	bool DoFile_Write(const char *szOutputFilename);
};

#endif
